<?php

/**
 * @package: patterns
 * @author: Yevhen Odynets
 * @date: 2025-07-06
 * @time: 16:23
 */

declare(strict_types = 1);

namespace Controller;

class DotEnvEnvironment
{
    public function load($path): void
    {
        $lines = file($path . '/.env');
        foreach ($lines as $line) {
            $split_line = explode('=', $line, 2);
            if (count($split_line) !== 2) {
                continue;
            }

            [$key, $value] = $split_line;
            $key = trim($key);
            $value = trim($value);

            putenv(sprintf('%s=%s', $key, $value));
            $_ENV[$key] = $value;
            $_SERVER[$key] = $value;
        }
    }
}
