<?php

/**
 * @parcel: patterns
 * @author: Yevhen Odynets
 * @date: 2025-07-03
 * @time: 20:15
 */

declare(strict_types = 1);

namespace Pattern\Creational\AbstractFactory;

class NovapostDeliveryFactory implements AbstractFactoryInterface
{
    public function createDeliveryService(): DeliveryServiceInterface
    {
        return new NovapostDeliveryService;
    }

    public function createParcel(): ParcelInterface
    {
        return new NovapostParcel;
    }
}
