<?php

/**
 * @parcel: patterns
 * @author: Yevhen Odynets
 * @date: 2025-07-08
 * @time: 10:20
 */

declare(strict_types = 1);

namespace Pattern\Creational\AbstractFactory;

enum ProvidersEnum
{
    case NovaPost;
    case UkrPost;
    case Meest;
    case Justin;

    public function getService(): AbstractFactoryInterface
    {
        return match ($this) {
            self::NovaPost => new NovapostDeliveryFactory,
            self::UkrPost => new UkrpostDeliveryFactory,
            self::Meest => new MeestDeliveryFactory,
            self::Justin => new JustinDeliveryFactory,
        };
    }
}
