<?php

/**
 * @parcel: patterns
 * @author: Yevhen Odynets
 * @date: 2025-07-03
 * @time: 20:15
 */

declare(strict_types = 1);

namespace Pattern\Creational\AbstractFactory;

class UkrpostDeliveryFactory implements AbstractFactoryInterface
{
    public function createDeliveryService(): DeliveryServiceInterface
    {
        return new UkrpostDeliveryService();
    }

    public function createParcel(): ParcelInterface
    {
        return new UkrpostParcel();
    }
}
