<?php

/**
 * @package: patterns
 * @author: Yevhen Odynets
 * @date: 2025-07-07
 * @time: 08:30
 */

declare(strict_types = 1);

namespace Pattern\SOLID\LiskovSubstitution;

/**
 * Let q(x) be a property provable about objects x of type T.
 * Then q(y) should be provable for objects y of type S where S is a subtype of T.
 *
 * Derived classes must be substitutable for their base classes.
 */
readonly class BirdRun
{
    public function __construct(private Bird $bird) {}

    public function run(): void
    {
        $flySpeed = $this->bird->fly();
    }
}
