<?php

/**
 * @package: patterns
 * @author: Yevhen Odynets
 * @date: 2025-07-06
 * @time: 23:22
 */

declare(strict_types = 1);

namespace Pattern\SOLID\SingleResponsibility;

use Carbon\Carbon;

final readonly class SalesReporter
{
    public function __construct(private SalesRepository $repository) {}

    public function between(string|Carbon $startDate, string|Carbon $endDate, SalesReportOutputInterface $formatter): string
    {
        $sales = $this->repository->between($startDate, $endDate);

        return $formatter->output($sales);
    }
}
