<?php

/**
 * @package: patterns
 * @author: Yevhen Odynets
 * @date: 2025-07-03
 * @time: 09:07
 */

declare(strict_types = 1);

use Random\RandomException;

/**
 * @param ...$vars
 *
 * @return void
 */
function dump(...$vars): void
{
    echo '<pre><code class="language-stylus">';
    var_dump(...$vars);
    echo '</code></pre>';
}

/**
 * @return string
 */
function trace(): string
{
    $traced = debug_backtrace();

    // Maybe this is useless, but anyway...
    $offset = __FUNCTION__ === $traced[0]['function'] ? 1 : 0;
    $traced = $traced[$offset];

    return sprintf('%s@%s:%d', $traced['function'], $traced['file'], $traced['line']);
}

/**
 * @throws RandomException
 */
function getFloatRange(): float
{
    return (float)random_int(1000, 999999) / 100;
}

/**
 * Flatten a multi-dimensional associative array with dots.
 *
 * @param  iterable  $array
 * @param  string  $prepend
 *
 * @return array
 * @throws RandomException
 */
//function array_dot(iterable $array, string $prepend = ''): array
//{
//    $results = [];
//
//    $flatten = static function ($data, $prefix) use (&$results, &$flatten): void {
//        foreach ($data as $key => $value) {
//            $newKey = $prefix.$key;
//
//            if (is_array($value) && ! empty($value)) {
//                $flatten($value, $newKey.'.');
//            } else {
//                $results[$newKey] = $value;
//            }
//        }
//    };
//
//    $flatten($array, $prepend);
//
//    return $results;
//}

function abord(int $code): void
{
    $response_message = $_SERVER['SERVER_PROTOCOL'];

    switch ($code) {
        case 404:
            $response_message .= $code . ' Not Found';
            break;
        case 500:
            $response_message .= $code . ' Internal Server Error';
            break;
        default:
            $response_message .= ' 501 Not Implemented';
            throw new RandomException($response_message, $code);
    }

    header($response_message);
    http_response_code($code);
    print($response_message);
}